<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RSoftKeyTemplate StructType
 * @subpackage Structs
 */
class RSoftKeyTemplate extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 100
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 100
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The baseSoftkeyTemplateName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $baseSoftkeyTemplateName;
    /**
     * The isDefault
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $isDefault;
    /**
     * The applications
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\Applications
     */
    public $applications;
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * Constructor method for RSoftKeyTemplate
     * @uses RSoftKeyTemplate::setName()
     * @uses RSoftKeyTemplate::setDescription()
     * @uses RSoftKeyTemplate::setBaseSoftkeyTemplateName()
     * @uses RSoftKeyTemplate::setIsDefault()
     * @uses RSoftKeyTemplate::setApplications()
     * @uses RSoftKeyTemplate::setUuid()
     * @param string $name
     * @param string $description
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $baseSoftkeyTemplateName
     * @param string $isDefault
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\Applications $applications
     * @param string $uuid
     */
    public function __construct($name = null, $description = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $baseSoftkeyTemplateName = null, $isDefault = null, \\Losc\CucmBundle\Model\Webservice\StructType\Applications $applications = null, $uuid = null)
    {
        $this
            ->setName($name)
            ->setDescription($description)
            ->setBaseSoftkeyTemplateName($baseSoftkeyTemplateName)
            ->setIsDefault($isDefault)
            ->setApplications($applications)
            ->setUuid($uuid);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RSoftKeyTemplate
     */
    public function setName($name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RSoftKeyTemplate
     */
    public function setDescription($description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get baseSoftkeyTemplateName value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getBaseSoftkeyTemplateName()
    {
        return $this->baseSoftkeyTemplateName;
    }
    /**
     * Set baseSoftkeyTemplateName value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $baseSoftkeyTemplateName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RSoftKeyTemplate
     */
    public function setBaseSoftkeyTemplateName(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $baseSoftkeyTemplateName = null)
    {
        $this->baseSoftkeyTemplateName = $baseSoftkeyTemplateName;
        return $this;
    }
    /**
     * Get isDefault value
     * @return string|null
     */
    public function getIsDefault()
    {
        return $this->isDefault;
    }
    /**
     * Set isDefault value
     * @param string $isDefault
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RSoftKeyTemplate
     */
    public function setIsDefault($isDefault = null)
    {
        $this->isDefault = $isDefault;
        return $this;
    }
    /**
     * Get applications value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\Applications|null
     */
    public function getApplications()
    {
        return $this->applications;
    }
    /**
     * Set applications value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\Applications $applications
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RSoftKeyTemplate
     */
    public function setApplications(\\Losc\CucmBundle\Model\Webservice\StructType\Applications $applications = null)
    {
        $this->applications = $applications;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\RSoftKeyTemplate
     */
    public function setUuid($uuid = null)
    {
        $this->uuid = $uuid;
        return $this;
    }
}
